/// <reference types="node" />
import { MessageAdapterOptions } from "@slack/interactive-messages/dist/adapter";
import { WebClientOptions } from "@slack/web-api";
import { MessageCallback, PheliaMessage, PheliaStorage, PheliaHome } from "./interfaces";
/** The main phelia client. Handles sending messages with phelia components */
export declare class Phelia {
    private client;
    private static Storage;
    private messageCache;
    private homeComponent;
    setStorage(storage: PheliaStorage): void;
    constructor(token: string, slackOptions?: WebClientOptions);
    postMessage<p>(message: PheliaMessage<p>, channel: string, props?: p): Promise<void>;
    registerComponents(components: PheliaMessage[]): void;
    registerHome(home: PheliaHome): void;
    appHomeHandler(home: PheliaHome): (payload: any) => Promise<void>;
    processAction(payload: any): Promise<void>;
    processSubmission(payload: any): Promise<void>;
    processOption(payload: any): Promise<{
        options: any;
        option_groups?: undefined;
    } | {
        option_groups: any;
        options?: undefined;
    }>;
    messageHandler(signingSecret: string, messages?: string | PheliaMessage[] | MessageCallback, home?: PheliaMessage, slackOptions?: MessageAdapterOptions): import("http").RequestListener;
}
